#    Kye - classic puzzle game
#    Copyright (C) 2005, 2006, 2007 Colin Phipps <cph@moria.org.uk>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import tarfile
from os.path import exists, join

xsize = 30
ysize = 20

version = "0.9.3"

kyepaths = ("levels","/usr/local/share/kye","/usr/share/kye")

def tryopen(filename,paths):
    """Returns a reading file handle for filename, searching through directories in the supplied paths."""
    try:
        f = open(filename)
        return f
    except IOError, e:
        for p in paths:
            try:
                f = open(join(p,filename))
                return f
            except IOError, e:
                0
    raise IOError, "Unable to find file "+filename

def findfile(filename):
    """Looks for filename, searching a built-in list of directories; returns the path where it finds the file."""
    if exists(filename): return filename
    for p in kyepaths:
        x = join(p,filename)
        if exists(x): return x

class KyeImageDir:
    def __init__(self,filename):
        self.tiles = {}
        tar = tarfile.open(filename,'r|gz')
        for tarinfo in tar:
            (tilename,ext) = tarinfo.name.split('.',2)
            self.tiles[tilename] = tar.extractfile(tarinfo).read()
        tar.close()

    def get_tile(self,tilename):
        """Returns the image file data for the requested tile."""
        return self.tiles[tilename]
